(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass'), require('@babel/runtime/regenerator'), require('ptokens-utils'), require('ptokens-node'), require('ptokens-providers')) :
  typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass', '@babel/runtime/regenerator', 'ptokens-utils', 'ptokens-node', 'ptokens-providers'], factory) :
  (global = global || self, factory(global.NodeSelector = {}, global._asyncToGenerator, global._classCallCheck, global._createClass, global._regeneratorRuntime, global['ptokens-utils'], global['ptokens-node'], global['ptokens-providers']));
}(this, (function (exports, _asyncToGenerator, _classCallCheck, _createClass, _regeneratorRuntime, ptokensUtils, ptokensNode, ptokensProviders) { 'use strict';

  _asyncToGenerator = _asyncToGenerator && Object.prototype.hasOwnProperty.call(_asyncToGenerator, 'default') ? _asyncToGenerator['default'] : _asyncToGenerator;
  _classCallCheck = _classCallCheck && Object.prototype.hasOwnProperty.call(_classCallCheck, 'default') ? _classCallCheck['default'] : _classCallCheck;
  _createClass = _createClass && Object.prototype.hasOwnProperty.call(_createClass, 'default') ? _createClass['default'] : _createClass;
  _regeneratorRuntime = _regeneratorRuntime && Object.prototype.hasOwnProperty.call(_regeneratorRuntime, 'default') ? _regeneratorRuntime['default'] : _regeneratorRuntime;

  var BOOT_TESTNET_ENDPOINT = 'https://testnet--bootnode-eu-1.p.network';
  var BOOT_MAINNET_ENDPOINT = 'https://mainnet--bootnode-eu-1.p.network';
  var getBootNodeEndpoint = function getBootNodeEndpoint(_network) {
    return _network === ptokensUtils.constants.networks.Mainnet ? BOOT_MAINNET_ENDPOINT : BOOT_TESTNET_ENDPOINT;
  };

  var NodeSelector = function () {
    function NodeSelector(_configs) {
      _classCallCheck(this, NodeSelector);
      if (_configs) this.setParams(_configs);
      this.nodes = [];
      this.provider = new ptokensProviders.HttpProvider();
    }
    _createClass(NodeSelector, [{
      key: "checkConnection",
      value: function () {
        var _checkConnection = _asyncToGenerator( _regeneratorRuntime.mark(function _callee(_endpoint, _timeout) {
          var _options,
              optionalPtoken,
              optionalHostBlockchain,
              optionalHostNetwork,
              optionalNativeBlockchain,
              optionalNativeNetwork,
              _yield$this$provider$,
              host_blockchain,
              host_network,
              native_blockchain,
              native_network,
              _args = arguments;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
                  optionalPtoken = _options.pToken, optionalHostBlockchain = _options.hostBlockchain, optionalHostNetwork = _options.hostNetwork, optionalNativeBlockchain = _options.nativeBlockchain, optionalNativeNetwork = _options.nativeNetwork;
                  _context.prev = 2;
                  this.provider.setEndpoint(_endpoint);
                  _context.next = 6;
                  return this.provider.call('GET', "/".concat(optionalPtoken || this.pToken, "-on-").concat(ptokensUtils.helpers.getBlockchainShortType(optionalHostBlockchain || this.hostBlockchain), "/get-info"), null, _timeout);
                case 6:
                  _yield$this$provider$ = _context.sent;
                  host_blockchain = _yield$this$provider$.host_blockchain;
                  host_network = _yield$this$provider$.host_network;
                  native_blockchain = _yield$this$provider$.native_blockchain;
                  native_network = _yield$this$provider$.native_network;
                  return _context.abrupt("return", Boolean(host_blockchain === (optionalHostBlockchain || this.hostBlockchain) && host_network === (optionalHostNetwork || this.hostNetwork) && native_blockchain === (optionalNativeBlockchain || this.nativeBlockchain) && native_network === (optionalNativeNetwork || this.nativeNetwork)));
                case 14:
                  _context.prev = 14;
                  _context.t0 = _context["catch"](2);
                  throw new Error("Error during checking node connection: ".concat(_context.t0.message));
                case 17:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[2, 14]]);
        }));
        function checkConnection(_x, _x2) {
          return _checkConnection.apply(this, arguments);
        }
        return checkConnection;
      }()
    }, {
      key: "getApi",
      value: function () {
        var _getApi = _asyncToGenerator( _regeneratorRuntime.mark(function _callee2() {
          var node;
          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  if (this.selectedNode) {
                    _context2.next = 7;
                    break;
                  }
                  _context2.next = 4;
                  return this.select();
                case 4:
                  node = _context2.sent;
                  if (node) {
                    _context2.next = 7;
                    break;
                  }
                  throw new Error('No Nodes Available');
                case 7:
                  return _context2.abrupt("return", this.selectedNode.api);
                case 10:
                  _context2.prev = 10;
                  _context2.t0 = _context2["catch"](0);
                  throw new Error("Error during getting node api: ".concat(_context2.t0.message));
                case 13:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 10]]);
        }));
        function getApi() {
          return _getApi.apply(this, arguments);
        }
        return getApi;
      }()
    }, {
      key: "select",
      value: function () {
        var _select = _asyncToGenerator( _regeneratorRuntime.mark(function _callee3() {
          var _options,
              timeout,
              forceFetchingNodes,
              optionalNodes,
              optionalPtoken,
              optionalHostBlockchain,
              optionalHostNetwork,
              optionalNativeBlockchain,
              optionalNativeNetwork,
              feature,
              filteredNodesByFeature,
              nodesNotReachable,
              index,
              selectedNode,
              _args3 = arguments;
          return _regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _options = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                  timeout = _options.timeout, forceFetchingNodes = _options.forceFetchingNodes, optionalNodes = _options.nodes, optionalPtoken = _options.pToken, optionalHostBlockchain = _options.hostBlockchain, optionalHostNetwork = _options.hostNetwork, optionalNativeBlockchain = _options.nativeBlockchain, optionalNativeNetwork = _options.nativeNetwork;
                  _context3.prev = 2;
                  if (!((this.nodes.length === 0 || forceFetchingNodes) && !optionalNodes)) {
                    _context3.next = 6;
                    break;
                  }
                  _context3.next = 6;
                  return this.fetchNodes(ptokensUtils.helpers.getNetworkType(optionalHostNetwork || this.hostNetwork));
                case 6:
                  feature = "".concat(optionalPtoken || this.pToken, "-on-").concat(ptokensUtils.helpers.getBlockchainShortType(optionalHostBlockchain || this.hostBlockchain));
                  filteredNodesByFeature = optionalNodes ? optionalNodes.filter(function (_ref) {
                    var features = _ref.features;
                    return features.includes(feature);
                  }) : this.nodes.filter(function (_ref2) {
                    var features = _ref2.features;
                    return features.includes(feature);
                  });
                  if (!(filteredNodesByFeature.length === 0)) {
                    _context3.next = 10;
                    break;
                  }
                  throw new Error("No nodes available relating to the selected pToken (".concat(feature, ")"));
                case 10:
                  nodesNotReachable = [];
                case 11:
                  index = Math.floor(Math.random() * filteredNodesByFeature.length);
                  selectedNode = filteredNodesByFeature[index];
                  _context3.next = 15;
                  return this.checkConnection(selectedNode.webapi, timeout || 30000, {
                    pToken: optionalPtoken,
                    nativeNetwork: optionalNativeNetwork,
                    nativeBlockchain: optionalNativeBlockchain,
                    hostNetwork: optionalHostNetwork,
                    hostBlockchain: optionalHostBlockchain
                  });
                case 15:
                  _context3.t0 = _context3.sent;
                  if (!_context3.t0) {
                    _context3.next = 18;
                    break;
                  }
                  _context3.t0 = !nodesNotReachable.includes(selectedNode);
                case 18:
                  if (!_context3.t0) {
                    _context3.next = 22;
                    break;
                  }
                  return _context3.abrupt("return", this.setSelectedNode(selectedNode.webapi, {
                    pToken: optionalPtoken,
                    hostBlockchain: optionalHostBlockchain
                  }));
                case 22:
                  if (!nodesNotReachable.includes(selectedNode)) {
                    nodesNotReachable.push(selectedNode);
                  }
                case 23:
                  if (!(nodesNotReachable.length === filteredNodesByFeature.length)) {
                    _context3.next = 25;
                    break;
                  }
                  throw new Error("All nodes relating to the selected pToken (".concat(feature, ") appear to be unavailable"));
                case 25:
                  _context3.next = 11;
                  break;
                case 27:
                  _context3.next = 32;
                  break;
                case 29:
                  _context3.prev = 29;
                  _context3.t1 = _context3["catch"](2);
                  throw new Error(_context3.t1.message);
                case 32:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[2, 29]]);
        }));
        function select() {
          return _select.apply(this, arguments);
        }
        return select;
      }()
    }, {
      key: "setSelectedNode",
      value: function setSelectedNode(_node) {
        var _options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var optionalPtoken = _options.pToken,
            optionalHostBlockchain = _options.hostBlockchain;
        if (_node instanceof ptokensNode.Node) {
          this.selectedNode = _node;
          return this.selectedNode;
        }
        this.selectedNode = new ptokensNode.Node({
          pToken: optionalPtoken || this.pToken,
          blockchain: optionalHostBlockchain || this.hostBlockchain,
          provider: new ptokensProviders.HttpProvider(_node)
        });
        return this.selectedNode;
      }
    }, {
      key: "setParams",
      value: function setParams(_configs) {
        var defaultNode = _configs.defaultNode,
            pToken = _configs.pToken;
        if (!ptokensUtils.helpers.isValidPTokenName(pToken)) throw new Error('Invalid pToken name');
        this.pToken = pToken.toLowerCase() === ptokensUtils.constants.pTokens.pETH ? ptokensUtils.constants.pTokens.pWETH : pToken.toLowerCase();
        var _helpers$parseParams = ptokensUtils.helpers.parseParams(_configs, _configs.nativeBlockchain ? ptokensUtils.helpers.getBlockchainType[_configs.nativeBlockchain] : ptokensUtils.helpers.getNativeBlockchainFromPtokenName(this.pToken)),
            hostBlockchain = _helpers$parseParams.hostBlockchain,
            hostNetwork = _helpers$parseParams.hostNetwork,
            nativeBlockchain = _helpers$parseParams.nativeBlockchain,
            nativeNetwork = _helpers$parseParams.nativeNetwork;
        this.hostBlockchain = hostBlockchain;
        this.hostNetwork = hostNetwork;
        this.nativeBlockchain = nativeBlockchain;
        this.nativeNetwork = nativeNetwork;
        this.selectedNode = defaultNode ? this.setSelectedNode(defaultNode) : null;
      }
    }, {
      key: "fetchNodes",
      value: function () {
        var _fetchNodes = _asyncToGenerator( _regeneratorRuntime.mark(function _callee4(_networkType) {
          return _regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.prev = 0;
                  this.provider.setEndpoint(getBootNodeEndpoint(_networkType));
                  _context4.next = 4;
                  return this.provider.call('GET', '/peers');
                case 4:
                  this.nodes = _context4.sent.peers;
                  return _context4.abrupt("return", this.nodes);
                case 8:
                  _context4.prev = 8;
                  _context4.t0 = _context4["catch"](0);
                  throw new Error(_context4.t0.message);
                case 11:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this, [[0, 8]]);
        }));
        function fetchNodes(_x3) {
          return _fetchNodes.apply(this, arguments);
        }
        return fetchNodes;
      }()
    }]);
    return NodeSelector;
  }();

  exports.NodeSelector = NodeSelector;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
